import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Electric_Square here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Electric_Square extends Actor
{
    public static final int TOTAL_BLINKS = 2,
    SIZE_0 = 8,
    SIZE_1 = 16,
    SIZE_2 = 32,
    SIZE_3 = 48,
    SIZE_4 = 64;
    public static GreenfootImage[] imgs0 = new GreenfootImage[15];
    public static GreenfootImage[] imgs1 = new GreenfootImage[15];
    public static GreenfootImage[] imgs2 = new GreenfootImage[15];
    public static GreenfootImage[] imgs3 = new GreenfootImage[15];
    public static GreenfootImage[] imgs4 = new GreenfootImage[15];

    private GreenfootImage[] imgsInUse = new GreenfootImage[15];
    private GreenfootImage img, storeImage;    
    private boolean onAndOff;
    private int blinkCount;
    private int imageCounter;
    private int mySize;
    private int speed;

    private boolean reversed;
    private boolean vertical;
    public Electric_Square()
    {
        this(1,true,true);
    }

    public Electric_Square(int base, boolean newReversed, boolean newVertical)
    {
        mySize = base;
        setImages();
        updateImage();
        speed = Greenfoot.getRandomNumber(10);
        reversed = newReversed;
        vertical = newVertical;
    }

    public static GreenfootImage makeImage(int newBase, int newAlpha)
    {
        GreenfootImage returnImg = new GreenfootImage(newBase * 2, newBase * 2);
        returnImg.setColor(new Color(250,0,0,newAlpha));
        returnImg.fill();
        returnImg.setColor(new Color(180,0,0,newAlpha));
        returnImg.fillRect(newBase / 2, newBase / 2, newBase, newBase);        
        return returnImg;
    }

    public void act()
    {
        orbit(vertical, reversed);
        blink();
        updateImage();
        if (blinkCount > TOTAL_BLINKS)
            getWorld().removeObject(this);
    }

    public void blink()
    {
        if (!onAndOff)
        {
            imageCounter++;
            if (imageCounter == imgsInUse.length - 1)
                onAndOff = true;
        }
        else if (onAndOff)
        {
            imageCounter--;
            if (imageCounter <= 0)
            {
                onAndOff = false;
                blinkCount++;        
            }
        }
    }

    public static void initializeImages()
    {
        imgs0[0] = new GreenfootImage(makeImage(SIZE_0, 255));
        imgs1[0] = new GreenfootImage(makeImage(SIZE_1, 255));
        imgs2[0] = new GreenfootImage(makeImage(SIZE_2, 255));        
        imgs3[0] = new GreenfootImage(makeImage(SIZE_3, 255));        
        imgs4[0] = new GreenfootImage(makeImage(SIZE_4, 255));

        for (int i = 1; i < imgs0.length; i++)
        {        
            imgs0[i] = makeImage(SIZE_0,255 - i * 15);
        }
        for (int i = 1; i < imgs1.length; i++)
        {        
            imgs1[i] = makeImage(SIZE_1,255 - i * 15);

        }
        for (int i = 1; i < imgs2.length; i++)
        {        
            imgs2[i] = makeImage(SIZE_2,255 - i * 15);

        }
        for (int i = 1; i < imgs3.length; i++)
        {        
            imgs3[i] = makeImage(SIZE_3,255 - i * 15);

        }
        for (int i = 1; i < imgs4.length; i++)
        {        
            imgs4[i] = makeImage(SIZE_4,255 - i * 15);

        }
    }

    public void setImages()
    {
        if (mySize == 0)
        {
            imgsInUse = imgs0;
        }
        else if (mySize == 1)
        {
            imgsInUse = imgs1;
        }
        else if (mySize == 2)
        {
            imgsInUse = imgs2;
        }
        else if (mySize == 3)
        {
            imgsInUse = imgs3;
        }
        else if (mySize == 4)
        {
            imgsInUse = imgs4;
        }
    }

    public int test()
    {
        return imgsInUse[imageCounter].getTransparency();
    }

    public void updateImage()
    {
        img = imgsInUse[imageCounter];
        setImage(img);
    }

    public void orbit(boolean isVertical, boolean isReversed)
    {
        if (!isReversed)
        {
            if (isVertical)  setLocation(getX(), getY() + speed);
            else  setLocation(getX() + speed, getY());
            speed++;
            if (speed > 10)
                speed *= -1;
        }
        else
        {
            if (isVertical)  setLocation(getX(), getY() - speed);
            else  setLocation(getX() - speed, getY());
            speed--;
            if (speed < -10)
                speed *= -1;            
            
        }
    }
    }
