import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Particle here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Particle extends Actor
{
    private final int FLASH_VALUE = 50;

    private GreenfootImage img;
    private Color myColor;

    private boolean flashing = false, 
    waveReverse = false,
    fadeSelect = false;
    private MouseInfo target;
    private int r,
    b,
    g,
    a,
    speed, 
    size,
    speedBoostDelay, 
    flashDelay,
    waveCounter,
    sizeDelay,
    oldX,
    oldY;

    /**
     * Act - do whatever the Particle wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public Particle()
    {
        target = Greenfoot.getMouseInfo();
        img = new GreenfootImage(25,25);
        myColor = new Color(0,0,255);
        img.setColor(myColor);
        img.drawOval(10,10,10,10);
        setImage(img);
        setRotation(Greenfoot.getRandomNumber(359));
    }

    public void act() 
    {
        updateMouseInfo();
        if (target != null) setRotation(fleeMouse());
        else setRotation(fleeCenter());


        updateRBG(myColor);
        move(5);
        grow();
        wave();
        fade();
        updateImage();
        if (atWorldEdge() || b < 20) getWorld().removeObject(this);
    }    

    public void grow()
    {
        sizeDelay++;
        if (sizeDelay > 5)
        {
            size+= 5;
            sizeDelay = 0;
        }

    }

    /**
     * you've seen it before
     */
    public boolean atWorldEdge()
    {
        if (getX() < img.getWidth()
        || getY() < img.getHeight()
        || getX() > getWorld().getWidth() - getImage().getWidth()
        || getY() > getWorld().getHeight() - getImage().getHeight())

        {
            return true;
        }
        else
        {
            return false;
        }
    }

    /**
     * turns a random amount, from from 0 - 10 or -10 to 0, depending on variable waveReverse
     * waveCounter reaches 10, then the boolean is flipped, and we turn the other way.
     */
    public void wave()
    {
        if (!waveReverse)
        {
            waveCounter++;
            turn (Greenfoot.getRandomNumber(10) + 1);
            if (waveCounter == 10)
            {
                waveReverse = true;
            }
        }
        if (waveReverse)
        {
            waveCounter--;
            turn (Greenfoot.getRandomNumber((10) + 1) * -1);
            if (waveCounter == -10)
            {
                waveReverse = false;
            }
        }
    }

    /**
     * reduces the blue value of the color until it's less than 5, then redraws the image
     **/
    public void fade()
    {
        if (b >= 5) myColor = new Color(r,g,b-5);
    }

    public void glow()
    {
        if (b < 240)  myColor = new Color(r,g,b+10);
    }

    /**
     * adds, then subtracts, a value to G and R which improve the brightness, then darken, to
     * simulate the appearance of flashing.
     * 
     * note: if we dont (b > FLASH_VALUE), the circles will start being green and yellow as the
     * blue fades almost all the way
     **/
    public void flash()
    {
        flashDelay++;
        if (flashDelay > 5)
        {
            flashDelay = 0;
            updateRBG(myColor);
            if (b > FLASH_VALUE)
            {
                if (!flashing)
                {
                    myColor = new Color(r-FLASH_VALUE,
                        g-FLASH_VALUE,
                        b);
                    flashing = true;

                }
                else
                {
                    myColor = new Color(r+ FLASH_VALUE,
                        g+FLASH_VALUE,
                        b);
                    flashing = false;
                }

            }
        }
    }

    public void updateImage()
    {
        img.setColor(myColor);
        img.drawOval(10,10,10,10);
        setImage(img);
    }

    /** 
     * Breaks up a color into RBGA values, and then stores them in stance variables, to be used
     * and modified by other methods.
     */
    public void updateRBG(Color clr)
    {
        r = clr.getRed();
        g = clr.getGreen();
        b = clr.getBlue();        
        a = clr.getAlpha();
    }
    public int fleeMouse()  
    {  
        if(target != null)  
        {  
            int xDiff = target.getX() - getX(),  
            yDiff = target.getY() - getY();  
            double angle = Math.toDegrees(Math.atan2(yDiff, xDiff));  
            int beforeReversed = (int)Math.round(angle);
            beforeReversed += 180;
            if (beforeReversed > 360)
            {
                beforeReversed -= 360;
            }
            return beforeReversed;
        }
        else return 0;
    }
    public int fleeCenter()
        {
            int xDiff = getWorld().getWidth() - getX(),
            yDiff = getWorld().getHeight() - getY();
            double angle = Math.toDegrees(Math.atan2(yDiff, xDiff));  
            int beforeReversed = (int)Math.round(angle);
            beforeReversed += 180;
            if (beforeReversed > 360)
            {
                beforeReversed -= 360;
            }
            return beforeReversed;
        }        
    

    
    public void updateMouseInfo()
    {

        if (target!=null)
        {
            oldX = target.getX();
            oldY = target.getY();
        }
        target = Greenfoot.getMouseInfo();
    }
}
